#include "ShaderConstants.fxh"
#include "util.fxh"

struct PS_Input
{
    float4 position : SV_Position;
    float4 color : COLOR;
    float3 pos : POS;
};

struct PS_Output
{
    float4 color : SV_Target;
};


ROOT_SIGNATURE
void main( in PS_Input PSInput, out PS_Output PSOutput )
{	
    float posc = length(PSInput.pos);
    float dia = pow(max(min(FOG_COLOR.r * 1.5, 1.0), 0.0), 1.2);
    float noite = 1.0 - dia;
    float4 fc = FOG_COLOR;
    float chuva = clamp((1.0 - pow(FOG_CONTROL.y + 0.1, 10.0)), 0.0, 1.0);
    float3 fc3 = FOG_COLOR.rgb;
    float3 ctemp =  lerp(lerp(float3(0.4, 0.8, 1.4), float3(0.0, 0.45, 0.9), noite) * fc3, fc3, smoothstep(0.12, 0.30, pow(posc, 1.0)));
    
 float4 f_cloud = lerp(float4(ctemp, PSInput.color.a), fc, chuva);
    f_cloud = lerp(f_cloud, FOG_COLOR, lerp(smoothstep(0.0, 1.0, pow(posc, 1.0)), smoothstep(0.0, 0.5, pow(posc, 0.65)), chuva));
    
	PSOutput.color = f_cloud;


}